/**
   @file
   @author Shin'ichiro NAKAOKA
*/

#ifndef CNOID_BODY_ZMP_SEQ_H_INCLUDED
#define CNOID_BODY_ZMP_SEQ_H_INCLUDED

#include <cnoid/Vector3Seq>
#include "exportdecl.h"

namespace cnoid {

    class CNOID_EXPORT ZMPSeq : public Vector3Seq
    {
    public:
        ZMPSeq(int nFrames = 0);
        ZMPSeq(const ZMPSeq& org);
        ZMPSeq(const Vector3Seq& org);
        virtual AbstractSeqPtr cloneSeq() const;

        static const std::string& key();
    };

    typedef boost::shared_ptr<ZMPSeq> ZMPSeqPtr;
        
    class BodyMotion;

    CNOID_EXPORT ZMPSeqPtr getZMPSeq(const BodyMotion& motion);
    CNOID_EXPORT ZMPSeqPtr getOrCreateZMPSeq(BodyMotion& motion);
    CNOID_EXPORT void clearZMPSeq(BodyMotion& motion);
}

#endif
