/**
   @author Shin'ichiro Nakaoka
*/

#ifndef CNOID_BODYPLUGIN_OSG_COLLISION_H_INCLUDED
#define CNOID_BODYPLUGIN_OSG_COLLISION_H_INCLUDED

#include <vector>
#include <osg/Drawable>
#include <cnoid/ColdetLinkPair>
#include "exportdecl.h"

namespace cnoid {

    class OSGCollision : public osg::Drawable
    {
    public:
        OSGCollision();
        OSGCollision(const OSGCollision& org, const osg::CopyOp& copyop = osg::CopyOp::SHALLOW_COPY);
            
        META_Object(cnoidBody, OSGCollision)
            
        virtual ~OSGCollision() { }

        void setColdetPairs(const std::vector<ColdetLinkPairPtr>& pairs) {
            ppairs = &pairs;
        };

    private:
            
        const std::vector<ColdetLinkPairPtr>* ppairs;

        virtual void drawImplementation(osg::RenderInfo& ri) const;
        virtual osg::BoundingBox computeBound() const;
    };
}

#endif
