
/*! @file
  @author Shin'ichiro Nakaoka
*/

#include <cnoid/Plugin>
#include <cnoid/ItemManager>
#include "ScenarioItem.h"
#include "ScenarioView.h"

using namespace boost;
using namespace cnoid;

namespace {

    class ScenarioPlugin : public Plugin
    {
    public:
        
        ScenarioPlugin() : Plugin("Scenario") {
            require("Body");
            require("Media");
        }

        virtual bool initialize() {
            
            ScenarioItem::initialize(this);
            addView(new ScenarioView());
            
            return true;
        }
    };
}

CNOID_IMPLEMENT_PLUGIN_ENTRY(ScenarioPlugin);
